#version 300 es

precision mediump float;

in vec2 texture_coord;
uniform vec2 resolution;
uniform float corner_radius;

out vec4 out_color;

void main() {
    float x = texture_coord[0] * resolution[0];
    float y = texture_coord[1] * resolution[1];
    bool is_need_color = true;
    if (x < corner_radius && y < corner_radius && length(vec2(x - corner_radius, y - corner_radius)) > corner_radius) {
        is_need_color = false;
    }
    else if (x < corner_radius && y > (resolution[1] - corner_radius) && length(vec2(x - corner_radius, resolution[1] - y - corner_radius)) > corner_radius) {
        is_need_color = false;
    } else if (x > resolution[0] - corner_radius && y < corner_radius && length(vec2(resolution[0] - x - corner_radius, y - corner_radius)) > corner_radius) {
        is_need_color = false;
    } else if (x > resolution[0] - corner_radius && y > resolution[1] - corner_radius && length(vec2(resolution[0] - x - corner_radius, resolution[1] - y - corner_radius)) > corner_radius) {
        is_need_color = false;
    }
   if (is_need_color) {
        out_color = vec4(1, 0, 0, 1);
    } else {
        out_color = vec4(1, 0, 1, 0);
    }
}
